﻿imports Extensibility
Imports System.Runtime.InteropServices
Imports msVisio = Microsoft.Office.Interop.Visio

#Region " Read me for Add-in installation and setup information. "
' When run, the Add-in wizard prepared the registry for the Add-in.
' At a later time, if the Add-in becomes unavailable for reasons such as:
'   1) You moved this project to a computer other than which is was originally created on.
'   2) You chose 'Yes' when presented with a message asking if you wish to remove the Add-in.
'   3) Registry corruption.
' you will need to re-register the Add-in by building the MyAddin1Setup project, 
' right click the project in the Solution Explorer, then choose install.
#End Region

<GuidAttribute("94477E7B-3C22-49BB-A388-76B1FDAFCC9D"), ProgIdAttribute("MyAddin1.Connect")> _
Public Class Connect
	
    Implements Extensibility.IDTExtensibility2
    Private vsApplication As msVisio.Application = Nothing

	Private applicationObject As Object
        Private addInInstance As Object
	
	Public Sub OnBeginShutdown(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnBeginShutdown
	End Sub
	
	Public Sub OnAddInsUpdate(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnAddInsUpdate
	End Sub
	
	Public Sub OnStartupComplete(ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnStartupComplete
	End Sub
	
	Public Sub OnDisconnection(ByVal RemoveMode As Extensibility.ext_DisconnectMode, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnDisconnection
	End Sub
	
	Public Sub OnConnection(ByVal application As Object, ByVal connectMode As Extensibility.ext_ConnectMode, ByVal addInInst As Object, ByRef custom As System.Array) Implements Extensibility.IDTExtensibility2.OnConnection
        Try
            If Not application Is Nothing Then
                vsApplication = CType(application, msVisio.Application)
                addInInstance = addInInst
            End If
        Catch ex As Exception
            MessageBox.Show("Es trat ein Fehler auf:" & _
                            System.Environment.NewLine & ex.Message)

        End Try
	End Sub

End Class
