﻿Public Class frmLayer
    Dim vsApp As Global.Microsoft.Office.Interop.Visio.Application
    Dim vsDatei As Global.Microsoft.Office.Interop.Visio.Document
    Dim vsBlatt As Global.Microsoft.Office.Interop.Visio.Page
    Dim vsLayer As Global.Microsoft.Office.Interop.Visio.Layer

    Private Sub frmLayer_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load


        Dim strLayer() As String
        Dim blnLayerDa As Boolean
        ReDim strLayer(0)

        Dim i As Integer
        vsApp = Globals.ThisAddIn.Application.Application
        Try
            vsDatei = vsApp.ActiveDocument
            For Each vsBlatt In vsDatei.Pages
                For Each vsLayer In vsBlatt.Layers
                    blnLayerDa = False
                    For i = 1 To UBound(strLayer)
                        If strLayer(i) = vsLayer.Name Then
                            blnLayerDa = True
                        End If
                    Next
                    If blnLayerDa = False Then
                        ReDim Preserve strLayer(UBound(strLayer) + 1)
                        strLayer(UBound(strLayer)) = vsLayer.Name
                    End If

                Next vsLayer
            Next vsBlatt
            For i = 1 To UBound(strLayer)
                Me.lstLayer.Items.Add(strLayer(i))
            Next

        Catch ex As Exception
            System.Windows.Forms.MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub butAbbrechen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butAbbrechen.Click
        Me.Close()
    End Sub

    Private Sub butEinblenden_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butEinblenden.Click
        Dim i As Integer
        For Each vsBlatt In vsDatei.Pages
            If vsBlatt.PageSheet.SectionExists(Visio.VisSectionIndices.visSectionLayer, 1) Then
                For i = 0 To vsBlatt.PageSheet.Section(Visio.VisSectionIndices.visSectionLayer).Count - 1

                    vsBlatt.PageSheet.Section(Visio.VisSectionIndices.visSectionLayer).Row(i).Cell(Visio.VisCellIndices.visLayerVisible).Formula = 1

                Next i
            End If
        Next vsBlatt
        Me.Close()
    End Sub

    Private Sub butAusblenden_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles butAusblenden.Click
        If Me.lstLayer.SelectedItems.Count = 0 Then
            System.Windows.Forms.MessageBox.Show("Bitte wählen Sie einen Eintrag aus!")
        Else
            Dim i As Integer
            For Each vsBlatt In vsDatei.Pages
                If vsBlatt.PageSheet.SectionExists(Visio.VisSectionIndices.visSectionLayer, 1) Then
                    For i = 0 To vsBlatt.PageSheet.Section(Visio.VisSectionIndices.visSectionLayer).Count - 1
                        If vsBlatt.PageSheet.Section(Visio.VisSectionIndices.visSectionLayer).Row(i).Cell(Visio.VisCellIndices.visLayerName).ResultStr("") = _
                            Me.lstLayer.SelectedItem.ToString Then
                            vsBlatt.PageSheet.Section(Visio.VisSectionIndices.visSectionLayer).Row(i).Cell(Visio.VisCellIndices.visLayerVisible).Formula = 0
                        End If
                    Next i
                End If
            Next vsBlatt
            Me.Close()
        End If
    End Sub
End Class